Package org.apache.lucene.analysis.miscellaneous

# Class ASCIIFoldingFilter

java.lang.Object
org.apache.lucene.util.AttributeSource
org.apache.lucene.analysis.TokenStream
org.apache.lucene.analysis.TokenFilter
org.apache.lucene.analysis.miscellaneous.ASCIIFoldingFilter

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Unwrappable<TokenStream>`

public final class ASCIIFoldingFilter extends TokenFilter
This class converts alphabetic, numeric, and symbolic Unicode characters which are not in the first 127 ASCII characters (the "Basic Latin" Unicode block) into their ASCII equivalents, if one exists.

Characters from the following Unicode blocks are converted; however, only those characters with reasonable ASCII alternatives are converted:

- C1 Controls and Latin-1 Supplement: http://www.unicode.org/charts/PDF/U0080.pdf
- Latin Extended-A: http://www.unicode.org/charts/PDF/U0100.pdf
- Latin Extended-B: http://www.unicode.org/charts/PDF/U0180.pdf
- Latin Extended Additional: http://www.unicode.org/charts/PDF/U1E00.pdf
- Latin Extended-C: http://www.unicode.org/charts/PDF/U2C60.pdf
- Latin Extended-D: http://www.unicode.org/charts/PDF/UA720.pdf
- IPA Extensions: http://www.unicode.org/charts/PDF/U0250.pdf
- Phonetic Extensions: http://www.unicode.org/charts/PDF/U1D00.pdf
- Phonetic Extensions Supplement: http://www.unicode.org/charts/PDF/U1D80.pdf
- General Punctuation: http://www.unicode.org/charts/PDF/U2000.pdf
- Superscripts and Subscripts: http://www.unicode.org/charts/PDF/U2070.pdf
- Enclosed Alphanumerics: http://www.unicode.org/charts/PDF/U2460.pdf
- Dingbats: http://www.unicode.org/charts/PDF/U2700.pdf
- Supplemental Punctuation: http://www.unicode.org/charts/PDF/U2E00.pdf
- Alphabetic Presentation Forms: http://www.unicode.org/charts/PDF/UFB00.pdf
- Halfwidth and Fullwidth Forms: http://www.unicode.org/charts/PDF/UFF00.pdf

See: http://en.wikipedia.org/wiki/Latin_characters_in_Unicode

For example, 'à' will be replaced by 'a'.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

  `AttributeSource.State`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

  `input`

  ### Fields inherited from class org.apache.lucene.analysis.TokenStream

  `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ASCIIFoldingFilter(TokenStream input)`
  `ASCIIFoldingFilter(TokenStream input, boolean preserveOriginal)`
  Create a new `ASCIIFoldingFilter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `foldToASCII(char[] input, int length)`
  Converts characters above ASCII to their ASCII equivalents.
  `static final int`
  `foldToASCII(char[] input, int inputPos, char[] output, int outputPos, int length)`
  Converts characters above ASCII to their ASCII equivalents.
  `boolean`
  `incrementToken()`
  `boolean`
  `isPreserveOriginal()`
  Does the filter preserve the original tokens?
  `void`
  `reset()`

  ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

  `close, end, unwrap`

  ### Methods inherited from class org.apache.lucene.util.AttributeSource

  `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ASCIIFoldingFilter

    public ASCIIFoldingFilter(TokenStream input)

  - ### ASCIIFoldingFilter

    public ASCIIFoldingFilter(TokenStream input, boolean preserveOriginal)
    Create a new `ASCIIFoldingFilter`.
    Parameters:
      `input` - TokenStream to filter
      `preserveOriginal` - should the original tokens be kept on the input stream with a 0 position increment from the folded tokens?

- ## Method Details

  - ### isPreserveOriginal

    public boolean isPreserveOriginal()
    Does the filter preserve the original tokens?

  - ### incrementToken

    public boolean incrementToken() throws IOException
    Specified by:
      `incrementToken` in class `TokenStream`
    Throws:
      `IOException`

  - ### reset

    public void reset() throws IOException
    Overrides:
      `reset` in class `TokenFilter`
    Throws:
      `IOException`

  - ### foldToASCII

    public void foldToASCII(char[] input, int length)
    Converts characters above ASCII to their ASCII equivalents. For example, accents are removed from accented characters.
    Parameters:
      `input` - The string to fold
      `length` - The number of characters in the input string

  - ### foldToASCII

    public static final int foldToASCII(char[] input, int inputPos, char[] output, int outputPos, int length)
    Converts characters above ASCII to their ASCII equivalents. For example, accents are removed from accented characters.
    Parameters:
      `input` - The characters to fold
      `inputPos` - Index of the first character to fold
      `output` - The result of the folding. Should be of size >= `length * 4`.
      `outputPos` - Index of output where to put the result of the folding
      `length` - The number of characters to fold
    Returns:
      length of output
    NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.